# std::greater

From cppreference.com
< cpp‎ | utility‎ | functional

Defined in header `<functional>` |  |
template< class T > struct greater; |  | (until C++14)
template< class T = void > struct greater; |  | (since C++14)

Function object for performing comparisons. Unless specialized, invokes operator> on type `T`.

### Specializations

A specialization of `std::greater` for any pointer type yields a strict total order, even if the built-in operator> does not. The strict total order is consistent among specializations of std::less, std::greater, std::less_equal, and std::greater_equal for that pointer type, and is also consistent with the partial order imposed by the corresponding built-in operators (`<`, `>`, `<=` and `>=`).

If the function call operator of the specialization `std::greater<void>` calls a built-in operator comparing pointers, it yields a strict total order even if the built-in operator> does not. This strict total order is consistent among the specializations `std::less<void>`, `std::greater<void>`, `std::less_equal<void>`, and `std::greater_equal<void>`, and is also consistent with the partial order imposed by the corresponding built-in operators.

(since C++14)

The standard library provides a specialization of `std::greater` when `T` is not specified, which leaves the parameter types and return type to be deduced.

greater<void> | function object implementing x > y deducing argument and return types (class template specialization)

(since C++14)

### Member types

Type | Definition
`result_type`(deprecated in C++17) | `bool`
`first_argument_type`(deprecated in C++17) | `T`
`second_argument_type`(deprecated in C++17) | `T`

(until C++20)

### Member functions

operator() | checks whether the first argument is greater than the second (public member function)

## std::greater::operator()

bool operator()( const T& lhs, const T& rhs ) const; |  | (until C++14)
constexpr bool operator()( const T& lhs, const T& rhs ) const; |  | (since C++14)

Checks whether `lhs` is greater than `rhs`.

### Parameters

lhs, rhs | - | values to compare

### Return value

true if lhs > rhs, false otherwise.

### Exceptions

(none)

### Possible implementation

    constexpr bool operator()(const T &lhs, const T &rhs) const
    {
        return lhs > rhs;
    }

### See also

less | function object implementing x < y (class template)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/utility/functional/greater&oldid=102524"